/** Functions for ADC **/

#include <stdint.h>
#include <avr/io.h>

void adc_init(void)
{
ADCSRA = (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);		// Maximum resolution, take some time
ADCSRA |= (1<<ADEN);					// Enable ADC
ADMUX  |= (0<<REFS1) | (1<<REFS0);			// Reference to AVCC
ADMUX  |= (1<<ADLAR);					// Left adjusted, it is sufficient to read ADCH
}

void adc_chan(unsigned char mux)
{
ADMUX  = (ADMUX&0xf0) | (mux&0x0f);
}

int adc_read(void)
{
ADCSRA |= (1<<ADSC);		// Start conversion
while(ADCSRA & (1<<ADSC));
return ADCH;
}
