/** Functions for button handling **/

#include <avr/io.h>

#include "adc.h"
#include "button.h"

static struct button_s button[]={
  {&DDRB,&PORTB,&PINB,5,0},
  {&DDRD,&PORTD,&PIND,5,1}
  };

static int axe[]={3,0};

void button_init(void){
int i;
for(i=0;i<BUTTON_NB;i++){
  *(button[i].ddr) &= ~(1<<button[i].index);
  if(button[i].pull) *(button[i].port) |= (1<<button[i].index);
  }
}

int button_get(int nb){
if(nb<0 || nb>=BUTTON_NB) return -1;
int pull=button[nb].pull;
return (*(button[nb].pin)&(1<<button[nb].index))?1-pull:pull;
}

void axe_init(void){
adc_init();
}

int axe_get(int nb){
if(nb<0 || nb>= AXE_NB) return -1;
adc_chan(axe[nb]);
int v=adc_read();
if(v>100 && v<160) return 0;
if(v>30 && v<90) return 2;
if(v>160 && v<220) return 1;
return -1;
}
