/** Functions for led handling **/

#include <avr/io.h>

#include "led.h"

static struct led_s led[]={
  {&DDRC,&PORTC,4},
  {&DDRC,&PORTC,5},
  {&DDRD,&PORTD,2},
  {&DDRD,&PORTD,4},
  {&DDRD,&PORTD,3},
  {&DDRD,&PORTD,6},
  {&DDRD,&PORTD,7},
  {&DDRB,&PORTB,0},
  {&DDRB,&PORTB,1},
  {&DDRB,&PORTB,2}
  };

void led_init(void){
int i;
for(i=0;i<LED_NB;i++) *led[i].ddr |= (1<<led[i].index);
for(i=0;i<LED_NB;i++) led_unset(i);
}

int led_set(int nb){
if(nb<0 || nb>= LED_NB) return -1;
*led[nb].port &= ~(1<<led[nb].index);
return 0;
}

int led_unset(int nb){
if(nb<0 || nb>= LED_NB) return -1;
*led[nb].port |= (1<<led[nb].index);
return 0;
}

int led_toggle(int nb){
if(nb<0 || nb>= LED_NB) return -1;
*led[nb].port ^= (1<<led[nb].index);
return 0;
}
