#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#include "serial.h"
#include "led.h"
#include "adc.h"
#include "button.h"

#define TEST_JOY

#define	CHAN_V	1
#define	CHAN_H	2

int main(void)
{
printf_init();
led_init();
button_init();
axe_init();

int i;
for(i=0;i<LED_NB;i++){ printf("LED on %d\n",i); led_set(i); _delay_ms(100); }
for(i=0;i<LED_NB;i++){ printf("LED off %d\n",i); led_unset(i); _delay_ms(100); }
while(1){
#ifdef TEST_BUTTON
  int b1=button_get(0);
  int b2=button_get(1);
  int a1=axe_get(0);
  int a2=axe_get(1);
  if(b1) led_set(LED_NB/2-1); else led_unset(LED_NB/2-1);
  if(b2) led_set(LED_NB/2); else led_unset(LED_NB/2); 
  if(a1&0x01) led_set(0); else led_unset(0);
  if(a1&0x02) led_set(LED_NB-1); else led_unset(LED_NB-1);
  if(a2&0x01) led_set(1); else led_unset(1);
  if(a2&0x02) led_set(LED_NB-2); else led_unset(LED_NB-2);
#endif
#ifdef TEST_JOY
  adc_chan(CHAN_V);
  int v=adc_read();
  adc_chan(CHAN_H);
  int h=adc_read();
  for(i=0;i<LED_NB/2;i++){
    if(i<v*LED_NB/500) led_set(i); else led_unset(i);
    }
  for(i=0;i<LED_NB/2;i++){
    if(i<h*LED_NB/500) led_set(i+LED_NB/2); else led_unset(i+LED_NB/2);
    }
#endif
  }
return 0;
}
